;===============================================================;
;                 	        				    ;
;===============================================================;

	LIST    p=16F628  	;   4 
	#include "P16F628.INC"  	

__CONFIG _WDT_ON&_EXTCLK_OSC&_PWRTE_ON&_CP_OFF&_MCLRE_OFF&_BODEN_ON&_LVP_OFF

; *****************************	; 
;        	
	cblock 0x20			;    
	;    
	NumH_GEN			;20
	NumL_GEN			;21
	Nh_GEN			;22
	Nl_GEN			;23
	Logic_GEN			;24	 
	T1high_GEN			;25 	.   1
	T1low_GEN			;26	.   1
	Number_GEN		;27 	   
	Gentime_GEN		;28 	  
	endc			;  

	org	0
init
	goto Begin
;--------------;   
	org	0x04
T1_int_servise
	incf PORTA,f;
	bcf PIR1,2;
	retfie;
;-------------------------------; 
Begin
 ;   
;------------- ------------------------

	movlw 0x07
	movwf CMCON

	bsf	STATUS,RP0	;  activate bank 1
	movlw   B'11111110'	;       RA0
    	movwf	TRISA		; 
	movlw   B'00010010'	;   
;	movlw   B'00000000'	;   MPLAB IDE
   	movwf	TRISB		; 
	bcf	STATUS,RP0	; activate bank 0
;-----------  --------------------------------
	movlw   B'10000000'	;
	movwf INTCON 	;
	movlw   B'00000000'	;
	movwf PIR1	;
;-----------  CCP  1----------------------
	movlw b'00001011' ; 10.2.2, 7.5
	movwf CCP1CON;
	bsf INTCON,6;
	bsf STATUS,RP0
	bsf PIE1,2; 	. .   CCP
	bcf STATUS,RP0
	movlw b'00001000'
	movwf T1CON     ; prescale=1:1, osc=1, 

	movlw b'00001100'
	movwf PORTB
;-----------    --------
again: 		Movlw .13 ;( 0x00)
	    	Movwf Number_GEN
			call Start_GEN ;  
			goto again
;===============================================================
Start_GEN
;--------------------------------------------------------
;	|		    		||
; 		|			|.		| 	|
;		|				|		|	|
;		|	Nl  	|   Nh	|T1high	|T1low			|  Gentime	|
;	f0	|  .229 	|   1     |	--	|	--		|	.70	|
;	f1	|  .177 	|   1     |	02	|	2b		|	.90	|
;	f2	|  .144 	|   1	|	01	|	c6		|	.110	|
;	f4	|  .122 	|   1	|	01	|	80		|	.130	|
;	f7	|  .104		|   1	|	01	|	4c		|	.150	|
;	f11	|   ---    	|   1	|	01	|	25		|	.170	|
;--------------------------------------------------------
;----------- -------------------------
gen_10_GEN
		Movlw .1			;  
		Movwf NumH_GEN		; 

gen_05_GEN
		Movf Number_GEN,w;		;    
		Sublw .15				;15 ( "")  
		Btfss STATUS,Z			;  . .
		goto gen_06_GEN			;   . 
		Movlw .150				; 
		Movwf Gentime_GEN		;   () 
		Movlw .121		;f4		;  
		Movwf NumL_GEN			;  
		Movlw 0x01		;f11		; 
		Movwf T1high_GEN			;  1
		Movlw 0x25		;f11		; 
		Movwf T1low_GEN			;  CCP
		goto gen_110_GEN			;  
gen_06_GEN
		Movf Number_GEN,w;		
		Sublw .13				; ""
		Btfss STATUS,Z
		goto gen_07_GEN
		Movlw .150
		Movwf Gentime_GEN
		Movlw .144		;f2
		Movwf NumL_GEN
		Movlw 0x01		;f11
		Movwf T1high_GEN	
		Movlw 0x25		;f11
		Movwf T1low_GEN
		goto gen_110_GEN
gen_07_GEN
		Movf Number_GEN,w
		Sublw .11				; 0
		Btfss STATUS,Z
		goto gen_20_GEN
		Movlw .130
		Movwf Gentime_GEN
		Movlw .121		;f4
		Movwf NumL_GEN
		Movlw 0x01		;f7
		Movwf T1high_GEN	
		Movlw 0x4c		;f7
		Movwf T1low_GEN
		goto gen_110_GEN
gen_20_GEN
		Movf Number_GEN,w
		Sublw .9
		Btfss STATUS,Z
		goto gen_30_GEN
		Movlw .110
		Movwf Gentime_GEN
		Movlw .144		;f2
		Movwf NumL_GEN
		Movlw 0x01		;f7
		Movwf T1high_GEN	
		Movlw 0x4c		;f7
		Movwf T1low_GEN
		goto gen_110_GEN
gen_30_GEN
		Movf Number_GEN,w
		Sublw .8
		Btfss STATUS,Z
		goto gen_40_GEN
		Movlw .90
		Movwf Gentime_GEN
		Movlw .177		;f1
		Movwf NumL_GEN
		Movlw 0x01		;f7
		Movwf T1high_GEN	
		Movlw 0x4c		;f7
		Movwf T1low_GEN
		goto gen_110_GEN
gen_40_GEN
		Movf Number_GEN,w
		Sublw .7
		Btfss STATUS,Z
		goto gen_50_GEN
		Movlw .70
		Movwf Gentime_GEN
		Movlw .229		;f0
		Movwf NumL_GEN
		Movlw 0x01 		;f7
		Movwf T1high_GEN	
		Movlw 0x4c		;f7
		Movwf T1low_GEN
		goto gen_110_GEN
gen_50_GEN
		Movf Number_GEN,w
		Sublw .6
		Btfss STATUS,Z
		goto gen_60_GEN
		Movlw .110
		Movwf Gentime_GEN
		Movlw .144		;f2
		Movwf NumL_GEN
		Movlw 0x01		;f4
		Movwf T1high_GEN	
		Movlw 0x80		;f4
		Movwf T1low_GEN
		goto gen_110_GEN
gen_60_GEN
		Movf Number_GEN,w
		Sublw .5
		Btfss STATUS,Z
		goto gen_70_GEN
		Movlw .90
		Movwf Gentime_GEN
		Movlw .178		;f1
		Movwf NumL_GEN
		Movlw 0x01		;f4
		Movwf T1high_GEN	
		Movlw 0x80		;f4
		Movwf T1low_GEN
		goto gen_110_GEN
gen_70_GEN
		Movf Number_GEN,w
		Sublw .4
		Btfss STATUS,Z
		goto gen_80_GEN
		Movlw .70
		Movwf Gentime_GEN
		Movlw .229		;f0
		Movwf NumL_GEN
		Movlw 0x01		;f4
		Movwf T1high_GEN	
		Movlw 0x80		;f4
		Movwf T1low_GEN
		goto gen_110_GEN
gen_80_GEN
		Movf Number_GEN,w
		Sublw .3
		Btfss STATUS,Z
		goto gen_90_GEN
		Movlw .90
		Movwf Gentime_GEN
		Movlw .178		;f1
		Movwf NumL_GEN
		Movlw 0x01		;f2
		Movwf T1high_GEN	
		Movlw 0xc6		;f2
		Movwf T1low_GEN
		goto gen_110_GEN
gen_90_GEN
		Movf Number_GEN,w
		Sublw .2
		Btfss STATUS,Z
		goto gen_100_GEN
		Movlw .70
		Movwf Gentime_GEN
		Movlw .231		;f0
		Movwf NumL_GEN
		Movlw 0x01		;f2
		Movwf T1high_GEN	
		Movlw 0xc6		;f2
		Movwf T1low_GEN
		goto gen_110_GEN
gen_100_GEN			
		Movf Number_GEN,w	;+++
		Sublw .1
		Btfss STATUS,Z
		goto gen_110_GEN
		Movlw .70
		Movwf Gentime_GEN
		Movlw .231		;f0
		Movwf NumL_GEN
		Movlw 0x02		;f1
		Movwf T1high_GEN	
		Movlw 0x2b		;f1
		Movwf T1low_GEN
;-------------------------------------------------------
gen_110_GEN
		Movf  T1high_GEN,w	;  
		Movwf CCPR1H		;  CCP  
		Movf  T1low_GEN,w	;  
		Movwf CCPR1L
		Clrf TMR1H			;  
		Clrf TMR1L			;  1
		Bsf T1CON,0	 		 ; T1
;---------------------------------------------
;   
;		t=(3*Nl+4)*Nh+12
;---------------------------------------------
cic3_GEN	
		Movf NumH_GEN,w	;+1
		Movwf Nh_GEN		;+1        
cic2_GEN
		Movf NumL_GEN,w		;+1
		Movwf Nl_GEN		;+1       
cic1_GEN
		Decfsz Nl_GEN		;+1(2) ,  . .  0
     	  	goto cic1_GEN		;+2
		Decfsz Nh_GEN		;+1(2) ,  . .  0
		goto cic2_GEN		;+2
		Comf PORTB,w		;+1	W<-PORTB	,W=not(W)
		Andlw B'00100000'		;+1	   W
		Movwf Logic_GEN		;+1	  Logic_GEN
		Movf PORTB,w		;+1	W<-PORTB
		Andlw B'11011111'		;+1	   W	
		Iorwf Logic_GEN,w		;+1	W  Logic_GEN
		Movwf PORTB		;+1	PORTB <- W
		decfsz Gentime_GEN	;+1	 -     
		goto cic3_GEN		;+2	Gentime_GEN  (50) 
		Bcf T1CON,0	 		;	 T1
		RETURN			;   	   
;===========================================================;
end

